C
C*************************************************************************
C*                                                                       *
C*                                                                       *
C*                                                                       *
C*              D R A W   -   C L I E N T   L I B R A R Y                *
C*                                                                       *
C*                    F O R T R A N     M O D U L E                      *
C*                                                                       *
C*                (Pannel Control Graphic Directives)                    *
C*                   (fortran Adaptation Support)                        *
C*                                                                       *
C*                    Draw Library Version V 2.4                         *
C*                                                                       *
C*                                by                                     *
C*                                                                       *
C*           Pierre Wolfers, Laboratoire de Cristallographie             *
C*                                                                       *
C*           CNRS GRENOBLE,  25 Avenue des Martyrs, B.P. 166             *
C*                                                                       *
C*                      F 38042 GRENOBLE CEDEX 9                         *
C*                                                                       *
C*                            F R A N C E                                *
C*                                                                       *
C*                                                                       *
C*                                                                       *
C*************************************************************************
C
C
C
C/////////////////////////////////////////////////////////////////////////
C//                                                                     //
C//                                                                     //
C// This license described in this file overrides all other licenses    //
C// that might be specified in other files for this library.            //
C//                                                                     //
C// This library is free software; you can redistribute it and/or       //
C// modify it under the terms of the GNU Lesser General Public          //
C// License as published by the Free Software Foundation; either        //
C// version 2.1 of the License, or (at your option) any later version.  //
C//                                                                     //
C// This library is distributed in the hope that it will be useful,     //
C// but WITHOUT ANY WARRANTY; without even the implied warranty of      //
C// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   //
C// Library General Public License for more details.                    //
C//                                                                     //
C// You should have received a copy of the GNU Lesser General Public    //
C// License along with this library (see COPYING.LIB); if not, write to //
C// the Free Software Foundation :                                      //
C//                      Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  //
C//                                                                     //
C/////////////////////////////////////////////////////////////////////////
C
C
C
	SUBROUTINE DRAW_PANNEL_FONT( IDE, LBF, NAM, OPT )
	IMPLICIT NONE
        INTEGER IDE, OPT
	LOGICAL LBF
	CHARACTER*(*) NAM

	EXTERNAL DRAW__PANNEL_FONT

	CALL  DRAW__PANNEL_FONT( IDE, LBF, NAM, LEN( NAM ), OPT )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_CREATE( W, H, NAM )
	IMPLICIT NONE
        REAL W, H
	CHARACTER*(*) NAM

	EXTERNAL DRAW__PANNEL_CREATE
	INTEGER DRAW__PANNEL_CREATE

	DRAW_PANNEL_CREATE =
     1                     DRAW__PANNEL_CREATE( W, H, NAM, LEN( NAM ) )
	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_B( ID, X, Y, W, H, LAB, FLG )
	IMPLICIT NONE
	INTEGER ID
	REAL X, Y, W, H
	CHARACTER*(*) LAB
	LOGICAL FLG(1)

	EXTERNAL DRAW__PANNEL_ADD_B
	INTEGER DRAW__PANNEL_ADD_B

	DRAW_PANNEL_ADD_B = 
     1       DRAW__PANNEL_ADD_B( ID, X, Y, W, H, LAB, LEN( LAB ), FLG )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_E( ID, X, Y, W, H, LAB,
     1                                           EV, NCH, CHOICES, MI )
	IMPLICIT NONE
	REAL X, Y, W, H
	INTEGER ID, EV(1), NCH, MI
	CHARACTER*(*) LAB, CHOICES(NCH)

	EXTERNAL DRAW__PANNEL_ADD_E
	INTEGER DRAW__PANNEL_ADD_E

	DRAW_PANNEL_ADD_E = DRAW__PANNEL_ADD_E( X, Y, W, H, LAB,
     1              LEN( LAB ), EV, NCH, LEN(CHOICES(1)), CHOICES, MI )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_S( ID, X, Y, W, H, LAB, SV,
     1                                                            FLG )
	IMPLICIT NONE
	INTEGER ID
	REAL X, Y, W, H
	CHARACTER*(*) LAB, SV
	LOGICAL FLG

	EXTERNAL DRAW__PANNEL_ADD_S
	INTEGER DRAW__PANNEL_ADD_S

	DRAW_PANNEL_ADD_S = DRAW__PANNEL_ADD_S( ID, X, Y, W, H, LAB,
     1         LEN( LAB ), SV, LEN( SV ), FLG )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_I( ID, X, Y, W, H, LAB,
     1                                                 IV, IMIN, IMAX )
	IMPLICIT NONE
	INTEGER ID, IV(1), IMIN, IMAX
	REAL X, Y, W, H
	CHARACTER*(*) LAB

	EXTERNAL DRAW__PANNEL_ADD_I
	INTEGER DRAW__PANNEL_ADD_I

	DRAW_PANNEL_ADD_I = DRAW__PANNEL_ADD_I( ID, X, Y, W, H, LAB,
     1                                     LEN( LAB ), IV, IMIN, IMAX )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_F( ID, X, Y, W, H, LAB,
     1                                           RV, RMIN, RMAX, RSTP )
	IMPLICIT NONE
	INTEGER ID
	REAL X, Y, W, H, RV(1), RMIN, RMAX, RSTP
	CHARACTER*(*) LAB

	EXTERNAL DRAW__PANNEL_ADD_F
	INTEGER DRAW__PANNEL_ADD_F

	DRAW_PANNEL_ADD_F = DRAW__PANNEL_ADD_F( ID, X, Y, W, H, LAB,
     1                               LEN( LAB ), RV, RMIN, RMAX, RSTP )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_TEXT( ID, X, Y, W, H, LAB,
     1                                                            TXT )
	IMPLICIT NONE
	INTEGER ID
	REAL X, Y, W, H
	CHARACTER*(*) LAB, TXT

	EXTERNAL DRAW__PANNEL_ADD_TEXT
	INTEGER DRAW__PANNEL_ADD_TEXT

	DRAW_PANNEL_ADD_TEXT = DRAW__PANNEL_ADD_TEXT( ID, X, Y, W, H,
     1                               LAB, LEN( LAB ), TXT, LEN( TXT ) )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_NEW_TEXT( ID, ITM, TXT )
	IMPLICIT NONE
	INTEGER ID, ITM
	CHARACTER*(*) TXT

	EXTERNAL DRAW__PANNEL_NEW_TEXT
	INTEGER DRAW__PANNEL_NEW_TEXT

	DRAW_PANNEL_NEW_TEXT = DRAW__PANNEL_NEW_TEXT( ID, ITM, TXT,
     1                                                     LEN( TXT ) )

	END
C
C======================================================================
C
	INTEGER FUNCTION DRAW_PANNEL_ADD_FRAME( ID, X, Y, W, H, LAB,
     1                                                       FLW, STL )
	IMPLICIT NONE
	INTEGER ID, STL
	REAL X, Y, W, H, FLW
	CHARACTER*(*) LAB

	EXTERNAL DRAW__PANNEL_ADD_FRAME
	INTEGER DRAW__PANNEL_ADD_FRAME

	DRAW_PANNEL_ADD_FRAME = DRAW__PANNEL_ADD_FRAME( ID, X, Y, W, H,
     1                                      LAB, LEN( LAB ), FLW, STL )

	END
C
C==============================  END  =================================
C



