// ****************************************************************************
// *                                                                          *
// *                                                                          *
// *                                                                          *
// *      F L T K     D R A W   -   S E R V E R   M E N U   M O D U L E       *
// *                                                                          *
// *           FLTK  Version  1.4-C for Draw Library Level V 2.4 A            *
// *                                                                          *
// *         (Perform Init menu tasks and manage the  menu requests)          *
// *                                                                          *
// *                                                                          *
// *                                  by                                      *
// *                                                                          *
// *            Pierre Wolfers, Laboratoire de Cristallographie               *
// *                                                                          *
// *            CNRS GRENOBLE,  25 Avenue des Martyrs, B.P. 166               *
// *                                                                          *
// *                       F 38042 GRENOBLE CEDEX 9                           *
// *                                                                          *
// *                             F R A N C E                                  *
// *                                                                          *
// *                                                                          *
// *                                                                          *
// ****************************************************************************

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                                                                           //
//   This license described in this file overrides all other licenses that   //
//   might be specified in other files for this library.                     //
//                                                                           //
//   This library is free software; you can redistribute it  and/or modify   //
//   it under the terms of the GNU Lesser General Public License as publi-   //
//   shed by  the  Free Software  Foundation;  either  version 2.1  of the   //
//   License, or (at your option) any later version.                         //
//                                                                           //
//   This library  is  distributed in  the  hope that  it will  be useful,   //
//   but   WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of   //
//   MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the GNU   //
//   Library General Public License for more details.                        //
//                                                                           //
//   You should have  received  a copy of  the  GNU Lesser General  Public   //
//   License  along with this library  (see COPYING.LIB); if not, write to   //
//   the Free Software Foundation :                                          //
//                        Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////




/*
  Routine to Request the User by using a FLTK ValueSlider Widget in a child window.
*/
int Draw_GetVal( const double min, const double max, const double stp,
                 double& def, const char* name, const int lgflg );

/*
  Routine to Request the User by using a FLTK Menu(MenuBar) Widget in a child window.
*/
int Draw_GetChoice( const char* title, char** menu );

/*
  Routine to Request the User by using a FLTK FileChooser Widget.
*/
char* Draw_GetFile( const char* title, const char* filter, const char* def, const int mod, int& fidx );

/*
  Routine to Request the User to get a color selection.
*/
int Draw_Get_Color( const char* str, float& r, float& g, float& b );

